
// TODO: Image loader
// TODO: help button
// TODO: mark new items
// TODO: think about checking new items and sorting
// TODO: cache in ajax? 



var theButton = null;
var theLocation = null;
var theMuxer = null;
var isConnected = false;

var theDefaultLocation = {
	country: {
		id: "us",
		name: "USA"
	},
	city: {
		id: "chicago",
		name: "Chicago"
	}
};

/// Message targets
const targetMain = "targetMain";
const targetDealsList = "targetDealsList";
const targetCitiesList = "targetCitiesList";

/// States
const stateLoading = 0;
const stateNetError = 1;
const stateNoDeals = 2;
const stateReady = 10;

/// Errors
const errorNet = "Sorry, service temporarily unreachable.";
const errorNoDeals = "Sorry, deals for this city are not available. Try to change city.";

/// Constants
const maxTitleLength = 82;
const updateInterval = 1800000;
const updateTimeout = 60000;


// Browser specific
//

// Log message
function Log(message)
{
	opera.postError(message);	
}

// Create button
function CreateButton()
{
	var UIItemProperties = {
		disabled: false,
		title: "Daily deals",
		icon: "icons/18.png",
		popup: {
			href: "deals.html",
			width: 330,
			height: 560
		},
		badge: {
	        display: "none",
	        textContent: "",
	        color: "white",
	        backgroundColor: "rgba(211, 0, 4, 1)"
	    }
	};
		
	theButton = opera.contexts.toolbar.createItem( UIItemProperties );
	opera.contexts.toolbar.addItem( theButton );	
}

// Hide badge
function HideBadge()
{
	if(theButton.badge.display != "none")
	{
		theButton.badge.display = "none";	
	}					
}

// Show badge with text
function ShowBadge(text)
{
	theButton.badge.textContent = " " + text + " ";
	theButton.badge.display = "block";	
}

// Send message to listeners
function SendMessage(target, type, message)
{
	message.target = target;
	message.type = type;
	
	opera.extension.broadcastMessage(message);	
}

opera.extension.ondisconnect = function() {
    isConnected = false;
    HideBadge();
};

opera.extension.onconnect = function() {
    isConnected = true;
};

opera.extension.onmessage = function(event) {
    HandleMessage(event.data);
};

window.addEventListener("load", function(){
	InitExtension();	
}, false);
 
//
// Browser specific end

var Url = {
    // public method for url encoding
	encode : function (string) {
		return escape(this._utf8_encode(string));
	},

	// public method for url decoding
	decode : function (string) {
		return this._utf8_decode(unescape(string));
	},

	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";

		for (var n = 0; n < string.length; n++) {

			var c = string.charCodeAt(n);

			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}

		return utftext;
	},

	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;

		while ( i < utftext.length ) {

			c = utftext.charCodeAt(i);

			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}

		}

		return string;
	}

};

/// Groupon deals source
function GrouponDealsSource(country, city) {	
	this._country = country;
	this._city = city;	
		
	this._xhr = new XMLHttpRequest();
	this._xhr.timeout = 20000;
}

GrouponDealsSource.prototype = {
    // Parse date
    makeDate : function(timestamp) {
        var yyyy = timestamp.substring(0, 4);
        var mo = parseInt(timestamp.substring(5, 7)) - 1;
        var dd = timestamp.substring(8, 10);
        var hh = parseInt(timestamp.substring(11, 13));
        var mi = parseInt(timestamp.substring(14, 16));
        var ss = timestamp.substring(17, 19);

        return new Date(Date.UTC(yyyy, mo, dd, hh, mi, ss));
    },

    // Format title
    formatTitle : function(title) {
        if (title.length > maxTitleLength) {
            return title.substr(0, maxTitleLength) + "...";
        }

        return title;
    },

    // Format price
    formatPrice : function(price) {
        if (price[0] == 'C') {
            return price.substr(1, price.length - 1);
        }

        return price;
    },

    // Load data asynchronously
    load : function(handler, callback, error) {
        this._xhr.open("GET", "http://api.groupon.com/v2/deals.json?division_id=" + this._city + "&client_id=f4bd8c72875bcd0cec6eb24dfd6c87a37735f485", true);
        this._xhr.parent = this;

        this._xhr.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lDeals = JSON.parse(this.responseText);
                    var lOut = [];

                    for (var x in lDeals.deals) {
                        var lDeal = {
                            source: "Groupon",
                            dealUrl: lDeals.deals[x].dealUrl,
                            longTitle: lDeals.deals[x].title,
                            shortTitle: this.parent.formatTitle(lDeals.deals[x].title),
                            image: lDeals.deals[x].sidebarImageUrl,
                            imageStyle: "width:150px;height:90px;",
                            price: this.parent.formatPrice(lDeals.deals[x].options[0].price.formattedAmount),
                            value: this.parent.formatPrice(lDeals.deals[x].options[0].value.formattedAmount),
                            discount: this.parent.formatPrice(lDeals.deals[x].options[0].discount.formattedAmount),
                            discountPercent: lDeals.deals[x].options[0].discountPercent,
                            startAt: this.parent.makeDate(lDeals.deals[x].startAt),
                            endAt: this.parent.makeDate(lDeals.deals[x].startAt),
                            sold: lDeals.deals[x].soldQuantity
                        };

                        lOut.push(lDeal);
                    }

                    callback(handler, lOut);
                }
                else {
                    error(handler);
                }
            }
        };

        try {
            this._xhr.send();
        }
        catch(e) {
            error(handler);
        }
    },

    // Stop
    stop : function() {
        this._xhr.abort();
    }
};

/// LivingSocial deals source
function LivingSocialDealsSource(country, city) {	
	this._country = country;
	this._city = city;	
	
			
	this._xhr = new XMLHttpRequest();
	this._xhr.timeout = 20000;
}

LivingSocialDealsSource.prototype = {
    // Parse date
    makeDate : function(timestamp) {
        return new Date(Date.parse(timestamp));
    },

    // Format title
    formatTitle : function(title) {
        if (title.length > maxTitleLength) {
            return title.substr(0, maxTitleLength) + "...";
        }

        return title;
    },

    // Format price
    formatPrice : function(price) {
        if (price[0] == 'C') {
            return price.substr(1, price.length - 1).replace(" ", "");
        }

        return price.replace(" ", "");
    },

    // Extract price value
    extractPriceValue : function(price) {
        var lFormatted = this.formatPrice(price);
        lFormatted = lFormatted.substr(1, lFormatted.length - 1);

        return parseFloat(lFormatted);
    },

    // Extract price currency
    extractPriceCurrency : function(price) {
        var lFormatted = this.formatPrice(price);
        return lFormatted[0];
    },

    // Format discount
    formatDiscount : function(price, value) {
        var lPrice = this.extractPriceValue(price);
        var lValue = this.extractPriceValue(value);
        var lCurrency = this.extractPriceCurrency(price);

        var lDiscount = lValue - lPrice;

        return lCurrency + lDiscount.toString();
    },

    // Load data asynchronously
    load : function(handler, callback, error) {
        this._xhr.open("GET", "http://livingsocial.com/cities/" + this._city + ".atom", true);
        this._xhr.parent = this;

        this._xhr.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lDeals = this.responseXML.documentElement.getElementsByTagName("entry");
                    var lOut = [];

                    var lUrlId = this.parent._city.match("\\d+");

                    for (var x = 0; x < lDeals.length; x++) {
                        //var lUrl = lDeals[x].getElementsByTagName("link")[0].attributes.getNamedItem("href").value + "?aff_id=668&offer_id=4";
                        var lUrl = "http://tracking.livingsocial.com/aff_c?offer_id=4&aff_id=668&url_id=" + lUrlId[0];
                        var lTitle = lDeals[x].getElementsByTagName("title")[0].textContent;
                        lTitle += " from " + lDeals[x].getElementsByTagNameNS("*", "merchant")[0].textContent;
                        var lImage = lDeals[x].getElementsByTagName("image_url")[0].textContent;
                        var lPrice = lDeals[x].getElementsByTagName("price")[0].textContent;
                        var lValue = lDeals[x].getElementsByTagName("value")[0].textContent;
                        var lDiscountPercent = lDeals[x].getElementsByTagName("savings")[0].textContent;
                        lDiscountPercent = lDiscountPercent.substr(0, lDiscountPercent.length - 1);
                        var lStartAt = lDeals[x].getElementsByTagName("published")[0].textContent;
                        var lEndAt = lDeals[x].getElementsByTagName("offer_ends_at")[0].textContent;
                        var lSold = lDeals[x].getElementsByTagName("orders_count")[0].textContent;

                        var lCur = new Date();
                        if (this.parent.makeDate(lEndAt) < lCur) {
                            continue;
                        }

                        var lDeal = {
                            source: "LivingSocial",
                            dealUrl: lUrl,
                            longTitle: lTitle,
                            shortTitle: this.parent.formatTitle(lTitle),
                            image: lImage,
                            imageStyle: "width:100px;height:143px;",
                            price: this.parent.formatPrice(lPrice),
                            value: this.parent.formatPrice(lValue),
                            discount: this.parent.formatDiscount(lPrice, lValue),
                            discountPercent: lDiscountPercent,
                            startAt: this.parent.makeDate(lStartAt),
                            endAt: this.parent.makeDate(lEndAt),
                            sold: lSold
                        };


                        lOut.push(lDeal);
                        break;
                    }

                    callback(handler, lOut);
                }
                else {
                    error(handler);
                }
            }
        };

        try {
            this._xhr.send();
        }
        catch(e) {
            error(handler);
        }
    },

    // Stop
    stop : function() {
        this._xhr.abort();
    }
};

/// Snuper deals source
function SnuperDealsSource(country, city) {	
	this._country = country;
	this._city = city;	
	
	var lStorId = 'snuprLast' + city;
	if (localStorage[lStorId] == null || isNaN(localStorage[lStorId])) {
		localStorage[lStorId] = 0;
	}
		
	this._xhr = new XMLHttpRequest();
	this._xhr.timeout = 20000;
}

SnuperDealsSource.prototype = {
    // Parse date
    makeDate : function(timestamp) {
        return new Date(Date.parse(timestamp));
    },

    // Format title
    formatTitle : function(title) {
        if (title.length > maxTitleLength) {
            return title.substr(0, maxTitleLength) + "...";
        }

        return title;
    },

    // Format price
    formatPrice : function(price) {
        var lFormatted = price.toLowerCase();
        lFormatted = lFormatted.replace("  ", "");
        lFormatted = lFormatted.replace(" ", "");
        lFormatted = lFormatted.replace("&nbsp;", "");
        return lFormatted;
    },

    // Extract price value
    extractPriceValue : function(price) {
        var lFormatted = this.formatPrice(price);
        lFormatted = lFormatted.match("[\\d\\s]+");

        return parseFloat(lFormatted[0]);
    },

    // Extract price currency
    extractPriceCurrency : function(price) {
        var lFormatted = this.formatPrice(price);
        var lPrice = this.extractPriceValue(price);
        lFormatted = lFormatted.replace(lPrice, "");
        return lFormatted;
    },

    // Format value
    formatValue : function(price, save) {
        var lPrice = this.extractPriceValue(price);
        var lSave = this.extractPriceValue(save);
        var lCurrency = this.extractPriceCurrency(price);

        var lValue = lSave + lPrice;
        return lValue.toString() + lCurrency;
    },

    // Load data asynchronously
    load : function(handler, callback, error) {
        this._xhr.open("GET", "http://pipes.yahoo.com/pipes/pipe.run?_id=58913d96f06dbf6e29eb3e571ff437d4&_render=json&city=" + this._city, true);
        this._xhr.parent = this;

        this._xhr.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lMax = 0;
                    var lStorId = 'snuprLast' + this.parent._city;

                    var lDeals = eval('(' + this.responseText + ')');
                    var lOut = [];
                    for (var x in lDeals.value.items) {
                        var lDeal = {
                            source: lDeals.value.items[x].service,
                            dealUrl: Url.decode(lDeals.value.items[x].link),
                            longTitle: lDeals.value.items[x].title,
                            shortTitle: this.parent.formatTitle(lDeals.value.items[x].title),
                            image: lDeals.value.items[x].image,
                            imageStyle: "width:150px;height:90px;",
                            price: this.parent.formatPrice(lDeals.value.items[x].price),
                            value: this.parent.formatValue(lDeals.value.items[x].price, lDeals.value.items[x].save),
                            discount: this.parent.formatPrice(lDeals.value.items[x].save),
                            discountPercent: lDeals.value.items[x].discount,
                            endAt: this.parent.makeDate(lDeals.value.items[x].date),
                            sold: lDeals.value.items[x].sold
                        };


                        if ((localStorage[lStorId] - lDeal.endAt.getTime()) < 0) {
                            if (lMax < lDeal.endAt.getTime()) {
                                lMax = lDeal.endAt.getTime();
                            }

                            var lDate = new Date();
                            lDate.setTime(parseInt(localStorage["last_checked"]) + 100000);

                            lDeal.startAt = lDate;
                        }
                        else {
                            var lDate1 = new Date();
                            lDate1.setTime(parseInt(localStorage["last_checked"]) - 100000);

                            lDeal.startAt = lDate1;
                        }


                        lOut.push(lDeal);
                    }

                    localStorage[lStorId] = lMax;

                    callback(handler, lOut);
                }
                else {
                    error(handler);
                }
            }
        };

        try {
            this._xhr.send();
        }
        catch(e) {
            error(handler);
        }
    },

    // Stop
    stop : function() {
        this._xhr.abort();
    }
};

/// Tippr deals source
function TipprDealsSource(country, city) {	
	this._country = country;
	this._city = city;	
		
	this._xhr = new XMLHttpRequest();
	this._xhr.timeout = 20000;
}

TipprDealsSource.prototype = {
    // Parse date
    makeDate : function(timestamp) {
        var yyyy = timestamp.substring(0, 4);
        var mo = parseInt(timestamp.substring(5, 7)) - 1;
        var dd = timestamp.substring(8, 10);
        var hh = parseInt(timestamp.substring(11, 13));
        var mi = parseInt(timestamp.substring(14, 16));
        var ss = timestamp.substring(17, 19);

        return new Date(Date.UTC(yyyy, mo, dd, hh, mi, ss));
    },

    // Format title
    formatTitle : function(title) {
        if (title.length > maxTitleLength) {
            return title.substr(0, maxTitleLength) + "...";
        }

        return title;
    },

    formatDiscount : function(discount) {
        if (discount.indexOf(".") == -1) {
            return discount;
        }

        var lFormatted = discount.substr(0, discount.indexOf(".") + 2);
        return lFormatted;
    },

    // Load data asynchronously
    load : function(handler, callback, error) {
        this._xhr.open("GET", "http://tippr.com/api/v2/offers/?apikey=64ef0c15200f374363cbe2b859bdfad1&format=json&publisher=tippr&channel=" + this._city + "&tracking_link=http://jump.tippr.com/aff_c?offer_id=2%2526aff_id=221", true);
        this._xhr.parent = this;

        this._xhr.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lDeals = JSON.parse(this.responseText);
                    var lOut = [];

                    for (var x in lDeals) {
                        var lStartDate = this.parent.makeDate(lDeals[x].start_date);
                        var lEndDate = this.parent.makeDate(lDeals[x].end_date);

                        for (var c in lDeals[x].channels) {
                            if (lDeals[x].channels[c].channel == this.parent._city) {
                                lStartDate = this.parent.makeDate(lDeals[x].channels[c].offer_start_time);
                                lEndDate = this.parent.makeDate(lDeals[x].channels[c].offer_end_time);
                            }
                        }

                        var lDeal = {
                            source: "Tippr",
                            dealUrl: lDeals[x].tracking_link,
                            longTitle: lDeals[x].headline,
                            shortTitle: this.parent.formatTitle(lDeals[x].headline),
                            image: lDeals[x].small_image_url,
                            imageStyle: "width:90px;height:90px;",
                            price: "$" + lDeals[x].price,
                            value: "$" + lDeals[x].value,
                            discount: "$" + lDeals[x].discount_amount,
                            discountPercent: this.parent.formatDiscount(lDeals[x].discount_percentage),
                            startAt: lStartDate,
                            endAt: lEndDate,
                            sold: lDeals[x].sold_quantity
                        };

                        lOut.push(lDeal);
                    }

                    callback(handler, lOut);
                }
                else {
                    error(handler);
                }
            }
        };

        try {
            this._xhr.send();
        }
        catch(e) {
            error(handler);
        }
    },

    // Stop
    stop : function() {
        this._xhr.abort();
    }
};

/// Dealster deals source
function DealsterDealsSource(country, city) {
	this._country = country;
	this._city = city;


	this._xhr = new XMLHttpRequest();
	this._xhr.timeout = 20000;
}

DealsterDealsSource.prototype = {
    // Parse date
    makeDate : function(timestamp) {
        return new Date(Date.parse(timestamp));
    },

    // Format title
    formatTitle : function(title) {
        if (title.length > maxTitleLength) {
            return title.substr(0, maxTitleLength) + "...";
        }

        return title;
    },

    // Extract price value
    extractPriceValue : function(price) {
        var lFormatted = price.substr(1, price.length - 1);
        return parseFloat(lFormatted);
    },

    fixDiscount : function(discount) {
        if (discount.indexOf(".") == -1) {
            return discount;
        }

        return discount.substr(0, discount.indexOf(".") + 2);
    },

    // Format discount in percents
    formatDiscountPercents : function(value, discount) {
        var lDiscount = this.extractPriceValue(discount);
        var lValue = this.extractPriceValue(value);

        var lDiscountPercent = (lDiscount / lValue) * 100;

        return this.fixDiscount(lDiscountPercent.toString());
    },

    // Load data asynchronously
    load : function(handler, callback, error) {
        this._xhr.open("GET", "http://www.dailydealster.com/feeds/" + this._city + "/deals", true);
        this._xhr.parent = this;

        this._xhr.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lDeals = this.responseXML.documentElement.getElementsByTagName("item");
                    var lOut = [];

                    for (var x = 0; x < lDeals.length; x++) {
                        var lUrl = "http://dealster.go2jump.org/aff_c?offer_id=2&aff_id=1134&url=";
                        lUrl += Url.encode(lDeals[x].getElementsByTagName("guid")[0].textContent);
                        var lTitle = lDeals[x].getElementsByTagName("title")[0].textContent;
                        var lImage = lDeals[x].getElementsByTagNameNS("*", "product_image")[0].textContent;
                        var lPrice = "$" + lDeals[x].getElementsByTagNameNS("*", "product_price")[0].textContent;
                        var lValue = "$" + lDeals[x].getElementsByTagNameNS("*", "product_value")[0].textContent;
                        var lDiscount = "$" + lDeals[x].getElementsByTagNameNS("*", "product_saving")[0].textContent;
                        var lStartAt = lDeals[x].getElementsByTagNameNS("*", "deal_start_date")[0].textContent;
                        var lEndAt = lDeals[x].getElementsByTagNameNS("*", "deal_end_date")[0].textContent;
                        var lSold = "na";


                        var lDeal = {
                            source: "Dealster",
                            dealUrl: lUrl,
                            longTitle: lTitle,
                            shortTitle: this.parent.formatTitle(lTitle),
                            image: lImage,
                            imageStyle: "width:111px;height:90px;",
                            price: lPrice,
                            value: lValue,
                            discount: lDiscount,
                            discountPercent: this.parent.formatDiscountPercents(lValue, lDiscount),
                            startAt: this.parent.makeDate(lStartAt),
                            endAt: this.parent.makeDate(lEndAt),
                            sold: lSold
                        };


                        lOut.push(lDeal);
                        break;
                    }

                    callback(handler, lOut);
                }
                else {
                    error(handler);
                }
            }
        };

        try {
            this._xhr.send();
        }
        catch(e) {
            error(handler);
        }
    },

    // Stop
    stop : function() {
        this._xhr.abort();
    }
};

/// HomeRun deals source
function HomeRunDealsSource(country, city) {	
	this._country = country;
	this._city = city;	
	
			
	this._xhr = new XMLHttpRequest();
	this._xhr.timeout = 20000;
}

HomeRunDealsSource.prototype = {
    // Parse date
    makeDate : function(timestamp) {
        var end_date_obj = new Date(Date.parse(timestamp));
        return end_date_obj;
    },

    // Format title
    formatTitle : function(title) {
        if (title.length > maxTitleLength) {
            return title.substr(0, maxTitleLength) + "...";
        }

        return title;
    },

    // Extract price value
    extractPriceValue : function(price) {
        var lFormatted = price.substr(1, price.length - 1);
        return parseFloat(lFormatted);
    },

    fixPoint : function(discount) {
        if (discount.indexOf(".") == -1) {
            return discount;
        }

        return discount.substr(0, discount.indexOf(".") + 2);
    },

    // Format discount
    formatDiscount : function(price, value) {
        var lPrice = this.extractPriceValue(price);
        var lValue = this.extractPriceValue(value);

        var lDiscount = lValue - lPrice;
        return "$" + this.fixPoint(lDiscount.toString());
    },

    // Format discount in percents
    formatDiscountPercents : function(value, discount) {
        var lDiscount = this.extractPriceValue(discount);
        var lValue = this.extractPriceValue(value);

        var lDiscountPercent = (lDiscount / lValue) * 100;

        return this.fixPoint(lDiscountPercent.toString());
    },

    // Load data asynchronously
    load : function(handler, callback, error) {
        this._xhr.open("GET", "https://homerun-ads.s3.amazonaws.com/live_deals.json", true);
        this._xhr.parent = this;

        this._xhr.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lRegions = JSON.parse(this.responseText);

                    var lDeals = [];
                    var lOut = [];

                    for (var x in lRegions) {
                        if (lRegions[x].region == this.parent._city) {
                            lDeals = lRegions[x].deals;
                            break;
                        }
                    }

                    for (var i in lDeals) {
                        var lUrl = lDeals[i].deal_url + "?_a=couponfox";
                        var lTitle = lDeals[i].title;
                        var lImage = lDeals[i].image_small;
                        var lImageWidth = lDeals[i].image_small_width;
                        var lImageHeight = lDeals[i].image_small_height;
                        var lPrice = "$" + (parseFloat(lDeals[i].price) / 100);
                        var lValue = "$" + (parseFloat(lDeals[i].value) / 100);
                        var lDiscount = this.parent.formatDiscount(lPrice, lValue);
                        var lStartAt = lDeals[i].start_at;
                        var lEndAt = lDeals[i].end_at;
                        var lSold = lDeals[i].num_purchased;

                        var lType = lDeals[i].type;
                        if (lType != "daily-deal" &&
                            lType != "city-sampler" &&
                            lType != "on-going")
                        {
                            continue;
                        }


                        var lDeal = {
                            source: "HomeRun",
                            dealUrl: lUrl,
                            longTitle: lTitle,
                            shortTitle: this.parent.formatTitle(lTitle),
                            image: lImage,
                            imageStyle: "width:135px;height:90px;",
                            price: lPrice,
                            value: lValue,
                            discount: this.parent.formatDiscount(lPrice, lValue),
                            discountPercent: this.parent.formatDiscountPercents(lValue, lDiscount),
                            startAt: this.parent.makeDate(lStartAt),
                            endAt: this.parent.makeDate(lEndAt),
                            sold: lSold
                        };


                        lOut.push(lDeal);
                        break;
                    }

                    callback(handler, lOut);
                }
                else {
                    error(handler);
                }
            }
        };

        try {
            this._xhr.send();
        }
        catch(e) {
            error(handler);
        }
    },

    // Stop
    stop : function() {
        this._xhr.abort();
    }
};

/// Dealster deals source
function ICouponsDealsSource(country, city) {
	this._country = country;
	this._city = city;


	this._xhr = new XMLHttpRequest();
	this._xhr.timeout = 20000;
}

ICouponsDealsSource.prototype = {
    // Parse date
    makeDate : function(timestamp) {
        return new Date(Date.parse(timestamp));
    },

    // Format title
    formatTitle : function(title) {
        if (title.length > maxTitleLength) {
            return title.substr(0, maxTitleLength) + "...";
        }

        return title;
    },

    // Load data asynchronously
    load : function(handler, callback, error) {
        this._xhr.open("GET", "http://icoupononline.com/rss_all.xml", true);
        this._xhr.parent = this;

        this._xhr.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lDeals = this.responseXML.documentElement.getElementsByTagName("item");
                    var lOut = [];

                    for (var x = 0; x < lDeals.length; x++) {
                        var lCity = lDeals[x].getElementsByTagName("city")[0].textContent;
                        lCity = lCity.toLowerCase().replace(" ", "-");
                        if (lCity != this.parent._city) {
                            continue;
                        }

                        var lUrl = Url.decode(lDeals[x].getElementsByTagName("url")[0].textContent) + "?aff_id=75";
                        var lTitle = lDeals[x].getElementsByTagName("title")[0].childNodes[0].nodeValue;
                        var lImage = lDeals[x].getElementsByTagName("img")[0].childNodes[0].nodeValue;
                        var lPrice = "$" + lDeals[x].getElementsByTagName("price")[0].textContent;
                        var lValue = "$" + lDeals[x].getElementsByTagName("value")[0].textContent;
                        var lDiscount = "$" + lDeals[x].getElementsByTagName("yousave")[0].textContent;
                        var lDiscountPercent = lDeals[x].getElementsByTagName("discount_percent")[0].textContent;
                        var lLastChecked = parseInt(localStorage["last_checked"]);
                        var lStartAt =  ((lLastChecked == "0") ? new Date() : new Date(lLastChecked - 1));
                        var lEndAt = lDeals[x].getElementsByTagName("expire_time")[0].textContent;
                        var lSold = "na";


                        var lDeal = {
                            source: "iCouponOnline",
                            dealUrl: lUrl,
                            longTitle: lTitle,
                            shortTitle: this.parent.formatTitle(lTitle),
                            image: lImage,
                            imageStyle: "width:111px;height:90px;",
                            price: lPrice,
                            value: lValue,
                            discount: lDiscount,
                            discountPercent: lDiscountPercent,
                            startAt: this.parent.makeDate(lStartAt),
                            endAt: this.parent.makeDate(lEndAt),
                            sold: lSold
                        };


                        lOut.push(lDeal);
                        break;
                    }

                    callback(handler, lOut);
                }
                else {
                    error(handler);
                }
            }
        };

        try {
            this._xhr.send();
        }
        catch(e) {
            error(handler);
        }
    },

    // Stop
    stop : function() {
        this._xhr.abort();
    }
};

function SourcesManager() {
	this._sources = {
		"groupon" : {
			locations : grouponLocations
		},
		"livingsocial" : {
			locations : livingSocialLocations
		},
		"snuper" : {
			locations : snuperLocations
		},
		"tippr" : {
			locations : tipprLocations
		},
		"dealster" : {
			locations : dealsterLocations
		},
		"homerun" : {
			locations : homerunLocations
		},
        "icoupons" : {
            locations : icoupononlineLocations
        }
	}	
}

SourcesManager.prototype = {
    createSources : function(countryId, cityId) {
        var lRet = [];
        for (var s in this._sources) {
            var lSourceDef = this._sources[s];
            if (lSourceDef.locations[countryId] && lSourceDef.locations[countryId].cities[cityId]) {
                var lSource = this.createSource(s, countryId, lSourceDef.locations[countryId].cities[cityId]);
                if (lSource) {
                    lRet.push(lSource);
                }
            }
        }

        if (lRet.length == 0) {
            return null;
        }

        return lRet;
    },

    createSource : function(name, countryId, cityId) {
        if (name == "groupon") {
            return new GrouponDealsSource(countryId, cityId);
        }

        if (name == "livingsocial") {
            return new LivingSocialDealsSource(countryId, cityId);
        }

        if (name == "snuper") {
            return new SnuperDealsSource(countryId, cityId);
        }

        if (name == "tippr") {
            return new TipprDealsSource(countryId, cityId);
        }

        if (name == "dealster") {
            return new DealsterDealsSource(countryId, cityId);
        }

        if (name == "homerun") {
            return new HomeRunDealsSource(countryId, cityId);
        }

        if (name == "icoupons")
        {
            return new ICouponsDealsSource(countryId, cityId);
        }

        return null;
    }
};

function UserLocation() {
	this._state = {
		stateId: stateLoading,
		message: ""
	};
	
	if(localStorage.locationSelected)
	{
		this._location = {
			country: {
				id: localStorage.countryId,
				name: localStorage.countryName
			},
			city: {
				id: localStorage.cityId,
				name: localStorage.cityName
			}
		};
		
		this.updateState(stateReady);
	}
	else
	{
		this.detectLocation();		
	}	 		
}

UserLocation.prototype = {
    updateState: function(id) {
        if (id == stateNetError) {
            this._state.message = errorNet;
            SendMessage(targetCitiesList, "error", { message: this._state.message});
        }
        else if (id == stateReady) {
            SendMessage(targetCitiesList, "update", { locations: allLocations, current: this._location });
        }

        this._state.stateId = id;
        setTimeout(OnInitialized, 1);
    },

    // Auto detect location by IP
    detectLocation : function() {
        var lRequest = new XMLHttpRequest();
        lRequest.open("GET", "http://freegeoip.net/json/", true);
        lRequest.parent = this;
        lRequest.onreadystatechange = function() {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    var lResponse = JSON.parse(this.responseText);
                    var lCountryId = lResponse.country_code.toLowerCase();
                    var lCityId = lResponse.city.toLowerCase().replace(" ", "_");

                    var location = {
                        country: {
                            id: lCountryId,
                            name: lResponse.country_name
                        },
                        city: {
                            id: lCityId,
                            name: lResponse.city
                        }
                    };

                    this.parent.saveLocation(location);
                }
                else {
                    this.parent.saveLocation(theDefaultLocation);
                }

                this.parent.updateState(stateReady);
            }
        };

        try {
            lRequest.send();
        }
        catch (e) {
            this.saveLocation(theDefaultLocation);
            this.updateState(stateReady);
        }
    },

    saveLocation : function(location) {
        localStorage.countryId = location.country.id;
        localStorage.countryName = location.country.name;
        localStorage.cityId = location.city.id;
        localStorage.cityName = location.city.name;
        localStorage.locationSelected = true;

        this._location = {
            country: {
                id: localStorage.countryId,
                name: localStorage.countryName
            },
            city: {
                id: localStorage.cityId,
                name: localStorage.cityName
            }
        };
    },

    currentState : function() {
        return this._state;
    },

    // Get current location
    currentLocation : function() {
        return this._location;
    },

    // Set current location
    setCurrentLocation : function(location) {
        this._location = location;

        localStorage.countryId = location.country.id;
        localStorage.countryName = location.country.name;
        localStorage.cityId = location.city.id;
        localStorage.cityName = location.city.name;
        localStorage.locationSelected = true;
    },

    // Get countries list (includes cities)
    getCountries : function() {
        return allLocations;
    }
};

function DealsMuxer(userLocation) {
	this._loaded = 0;
	this._errors = 0;
	
	this._sources = this.createSources(userLocation.currentLocation());	
	this._deals = [];	
	this._state = {
		stateId: stateLoading,
		message: ""
	};
	
	if (localStorage['last_checked'] == null || isNaN(localStorage['last_checked'])) {
		localStorage['last_checked'] = 0;
	}
	
	this.reloadDeals();
	this._timer = setInterval(function(){
		theMuxer.reloadDeals();
	}, updateInterval);
}

DealsMuxer.prototype = {
    // Handle location change
    changeLocation : function(userLocation) {
        this.reset();

        this._sources = this.createSources(userLocation);

        localStorage['last_checked'] = 0;
        this.reloadDeals();
    },

    // Create sources
    createSources : function(userLocation) {
        var lManager = new SourcesManager();
        return lManager.createSources(userLocation.country.id, userLocation.city.id);
    },

    // Reset muxer
    reset : function() {
        clearInterval(this._timer);
        if (this._sources != null) {
            for (var x in this._sources) {
                this._sources[x].stop();
            }

            this._sources = null;
        }

        this._deals = [];
        this._loaded = 0;
    },

    // Reload
    reloadDeals : function() {
        this.updateState(stateLoading);

        this._deals = [];
        this._loaded = 0;
        this._errors = 0;

        if (this._sources == null) {
            this.updateState(stateNoDeals);
        }
        else {
            for (var x in this._sources) {
                this._sources[x].load(this, function(obj, data) {
                    obj.onLoaded(data);
                }, function(obj) {
                    obj.onLoadError()
                });
            }
        }
    },

    // On load handler
    onLoaded : function(deals) {
        this._deals = this._deals.concat(deals);
        this._loaded++;

        if (this._loaded >= this._sources.length) {
            this.handleDeals();
        }
    },

    // On load handler
    onLoadError : function(deals) {
        this._loaded++;
        this._errors++;
        if (this._loaded >= this._sources.length) {
            this.handleDeals();
        }
    },

    // Handle deals
    handleDeals : function() {
        if (this._deals.length > 0) {
            this._deals.sort(function(a, b) {
                return b.startAt - a.startAt;
            });

            var newItems = 0;
            for (var x in this._deals) {
                if ((localStorage['last_checked'] - this._deals[x].startAt.getTime()) < 0) {
                    var image1 = new Image();
                    image1.src = this._deals[x].image;

                    newItems++;
                }
            }

            if (newItems > 0) {
                if (!isConnected) {
                    ShowBadge(newItems.toString());
                }
            }

            this.updateState(stateReady);
            SendMessage(targetDealsList, "update", { "deals": this._deals, "newItems": (newItems > 0) });
        }
        else {
            if (this._errors > 0) {
                this.updateState(stateNetError);
            }
            else {
                this.updateState(stateNoDeals);
            }
        }
    },

    // Return current state
    currentState : function() {
        return this._state;
    },

    // Update state of muxer
    updateState : function(id) {
        this._state.stateId = id;
        if (this._state.stateId == stateNetError) {
            this._state.message = errorNet;
            SendMessage(targetDealsList, "error", { message: this._state.message });

            setTimeout(function() {
                theMuxer.reloadDeals();
            }, updateTimeout);
        }
        else if (this._state.stateId == stateNoDeals) {
            this._state.message = errorNoDeals;
            SendMessage(targetDealsList, "error", { message: this._state.message });

            setTimeout(function() {
                theMuxer.changeLocation(theLocation.currentLocation());
            }, updateTimeout * 2);
        }
    }
};

function InitExtension()
{	
	CreateButton();
	
	theLocation = new UserLocation();		
}

function OnInitialized()
{
	if(theLocation.currentState().stateId != stateLoading && localStorage.locationSelected)
	{
		theMuxer = new DealsMuxer(theLocation);	
	}		
}

function HandleMessage(message)
{
	if(message.target != targetMain)
	{
		return;	
	}
	
	if(theMuxer == null)
	{
		return;
	}
	
	if(message.type == "loadData")
	{	
		if(theMuxer.currentState().stateId == stateReady)
		{
			SendMessage(targetDealsList, "update", { deals: theMuxer._deals });
		}
		else if(theMuxer.currentState().stateId != stateLoading)
		{
			SendMessage(targetDealsList, "error", { message : theMuxer.currentState().message });
		}
	}
	
	if(message.type == "setLocation")	
	{
		theLocation.setCurrentLocation(message.location);
		theMuxer.changeLocation(theLocation.currentLocation());
	}	
	
	if(message.type == "loadCity")
	{
		if(theLocation.currentState().stateId == stateReady)
		{
			var lLocations = theLocation.getCountries();
			var lCurrent = theLocation.currentLocation();
			
			var lMessage = {
				"locations": lLocations, 
				"current": lCurrent
			};
			
			SendMessage(targetCitiesList, "update", lMessage);
		}
		else if(theLocation.currentState().stateId != stateLoading)
		{
			SendMessage(targetCitiesList, "error", { message : theLocation.currentState().message });
		}	
	}
}
